package dev.shadowsoffire.apotheosis;

import net.minecraft.core.registries.Registries;
import net.minecraft.world.damagesource.DamageType;
import net.minecraft.resources.ResourceKey;
import net.minecraft.core.particles.SimpleParticleType;
import dev.shadowsoffire.placebo.util.PlaceboUtil;
import dev.shadowsoffire.apotheosis.adventure.affix.reforging.ReforgingRecipe;
import dev.shadowsoffire.apotheosis.adventure.affix.salvaging.SalvagingRecipe;
import dev.shadowsoffire.apotheosis.spawn.modifiers.SpawnerModifier;
import dev.shadowsoffire.apotheosis.ench.table.EnchantingRecipe;
import dev.shadowsoffire.apotheosis.village.fletching.FletchingRecipe;
import net.minecraft.world.item.crafting.RecipeType;
import net.minecraft.tags.BlockTags;
import net.minecraft.tags.ItemTags;
import net.minecraft.world.level.block.Block;
import net.minecraft.tags.TagKey;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixRegistry;
import dev.shadowsoffire.apotheosis.adventure.affix.effect.RadialAffix;
import dev.shadowsoffire.apotheosis.adventure.affix.effect.OmneticAffix;
import dev.shadowsoffire.apotheosis.adventure.affix.effect.TelepathicAffix;
import dev.shadowsoffire.apotheosis.adventure.affix.effect.FestiveAffix;
import dev.shadowsoffire.apotheosis.adventure.affix.effect.MagicalArrowAffix;
import dev.shadowsoffire.apotheosis.adventure.affix.effect.DurableAffix;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import dev.shadowsoffire.apotheosis.adventure.affix.augmenting.AugmentingTableTile;
import dev.shadowsoffire.apotheosis.adventure.affix.salvaging.SalvagingTableTile;
import dev.shadowsoffire.apotheosis.adventure.affix.reforging.ReforgingTableTile;
import dev.shadowsoffire.apotheosis.adventure.boss.BossSpawnerBlock;
import dev.shadowsoffire.apotheosis.ench.anvil.AnvilTile;
import dev.shadowsoffire.apotheosis.ench.library.EnchLibraryTile;
import net.minecraft.world.level.block.entity.BlockEntityType;
import dev.shadowsoffire.apotheosis.ench.table.ApothEnchantmentMenu;
import dev.shadowsoffire.apotheosis.ench.library.EnchLibraryContainer;
import dev.shadowsoffire.apotheosis.village.fletching.FletchingContainer;
import net.minecraft.world.inventory.MenuType;
import dev.shadowsoffire.apotheosis.village.fletching.arrows.MiningArrowEntity;
import dev.shadowsoffire.apotheosis.village.fletching.arrows.ExplosiveArrowEntity;
import dev.shadowsoffire.apotheosis.village.fletching.arrows.BroadheadArrowEntity;
import dev.shadowsoffire.apotheosis.village.fletching.arrows.ObsidianArrowEntity;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.item.alchemy.Potion;
import dev.shadowsoffire.apotheosis.spawn.enchantment.CapturingEnchant;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraft.resources.ResourceLocation;
import dev.shadowsoffire.apotheosis.garden.EnderLeadItem;
import dev.shadowsoffire.apotheosis.village.fletching.arrows.MiningArrowItem;
import dev.shadowsoffire.apotheosis.village.fletching.arrows.ExplosiveArrowItem;
import dev.shadowsoffire.apotheosis.village.fletching.arrows.BroadheadArrowItem;
import dev.shadowsoffire.apotheosis.village.fletching.arrows.ObsidianArrowItem;
import net.minecraft.world.item.Item;
import dev.shadowsoffire.apotheosis.potion.PotionCharmItem;
import net.minecraftforge.registries.RegistryObject;
import dev.shadowsoffire.placebo.registry.RegObjHelper;

public class Apoth
{
    public static final RegObjHelper R;
    
    static {
        R = new RegObjHelper("apotheosis");
    }
    
    public static final class Items
    {
        public static final RegistryObject<PotionCharmItem> POTION_CHARM;
        public static final RegistryObject<Item> LUCKY_FOOT;
        public static final RegistryObject<ObsidianArrowItem> OBSIDIAN_ARROW;
        public static final RegistryObject<BroadheadArrowItem> BROADHEAD_ARROW;
        public static final RegistryObject<ExplosiveArrowItem> EXPLOSIVE_ARROW;
        public static final RegistryObject<MiningArrowItem> IRON_MINING_ARROW;
        public static final RegistryObject<MiningArrowItem> DIAMOND_MINING_ARROW;
        public static final RegistryObject<EnderLeadItem> ENDER_LEAD;
        public static final RegistryObject<Item> SKULL_FRAGMENT;
        
        static {
            POTION_CHARM = Apoth.R.item("POTION_CHARM");
            LUCKY_FOOT = Apoth.R.item("LUCKY_FOOT");
            OBSIDIAN_ARROW = Apoth.R.item("OBSIDIAN_ARROW");
            BROADHEAD_ARROW = Apoth.R.item("BROADHEAD_ARROW");
            EXPLOSIVE_ARROW = Apoth.R.item("EXPLOSIVE_ARROW");
            IRON_MINING_ARROW = Apoth.R.item("IRON_MINING_ARROW");
            DIAMOND_MINING_ARROW = Apoth.R.item("DIAMOND_MINING_ARROW");
            ENDER_LEAD = Apoth.R.item("ENDER_LEAD");
            SKULL_FRAGMENT = RegistryObject.create(new ResourceLocation("wstweaks", "fragment"), ForgeRegistries.ITEMS);
        }
    }
    
    public static final class Enchantments
    {
        public static final RegistryObject<CapturingEnchant> CAPTURING;
        
        static {
            CAPTURING = Apoth.R.enchant("CAPTURING");
        }
    }
    
    public static final class Potions
    {
        public static final RegistryObject<Potion> RESISTANCE;
        public static final RegistryObject<Potion> LONG_RESISTANCE;
        public static final RegistryObject<Potion> STRONG_RESISTANCE;
        public static final RegistryObject<Potion> ABSORPTION;
        public static final RegistryObject<Potion> LONG_ABSORPTION;
        public static final RegistryObject<Potion> STRONG_ABSORPTION;
        public static final RegistryObject<Potion> HASTE;
        public static final RegistryObject<Potion> LONG_HASTE;
        public static final RegistryObject<Potion> STRONG_HASTE;
        public static final RegistryObject<Potion> FATIGUE;
        public static final RegistryObject<Potion> LONG_FATIGUE;
        public static final RegistryObject<Potion> STRONG_FATIGUE;
        public static final RegistryObject<Potion> SUNDERING;
        public static final RegistryObject<Potion> LONG_SUNDERING;
        public static final RegistryObject<Potion> STRONG_SUNDERING;
        public static final RegistryObject<Potion> KNOWLEDGE;
        public static final RegistryObject<Potion> LONG_KNOWLEDGE;
        public static final RegistryObject<Potion> STRONG_KNOWLEDGE;
        public static final RegistryObject<Potion> WITHER;
        public static final RegistryObject<Potion> LONG_WITHER;
        public static final RegistryObject<Potion> STRONG_WITHER;
        public static final RegistryObject<Potion> VITALITY;
        public static final RegistryObject<Potion> LONG_VITALITY;
        public static final RegistryObject<Potion> STRONG_VITALITY;
        public static final RegistryObject<Potion> GRIEVOUS;
        public static final RegistryObject<Potion> LONG_GRIEVOUS;
        public static final RegistryObject<Potion> STRONG_GRIEVOUS;
        public static final RegistryObject<Potion> LEVITATION;
        public static final RegistryObject<Potion> FLYING;
        public static final RegistryObject<Potion> LONG_FLYING;
        public static final RegistryObject<Potion> EXTRA_LONG_FLYING;
        
        static {
            RESISTANCE = Apoth.R.potion("RESISTANCE");
            LONG_RESISTANCE = Apoth.R.potion("LONG_RESISTANCE");
            STRONG_RESISTANCE = Apoth.R.potion("STRONG_RESISTANCE");
            ABSORPTION = Apoth.R.potion("ABSORPTION");
            LONG_ABSORPTION = Apoth.R.potion("LONG_ABSORPTION");
            STRONG_ABSORPTION = Apoth.R.potion("STRONG_ABSORPTION");
            HASTE = Apoth.R.potion("HASTE");
            LONG_HASTE = Apoth.R.potion("LONG_HASTE");
            STRONG_HASTE = Apoth.R.potion("STRONG_HASTE");
            FATIGUE = Apoth.R.potion("FATIGUE");
            LONG_FATIGUE = Apoth.R.potion("LONG_FATIGUE");
            STRONG_FATIGUE = Apoth.R.potion("STRONG_FATIGUE");
            SUNDERING = Apoth.R.potion("SUNDERING");
            LONG_SUNDERING = Apoth.R.potion("LONG_SUNDERING");
            STRONG_SUNDERING = Apoth.R.potion("STRONG_SUNDERING");
            KNOWLEDGE = Apoth.R.potion("KNOWLEDGE");
            LONG_KNOWLEDGE = Apoth.R.potion("LONG_KNOWLEDGE");
            STRONG_KNOWLEDGE = Apoth.R.potion("STRONG_KNOWLEDGE");
            WITHER = Apoth.R.potion("WITHER");
            LONG_WITHER = Apoth.R.potion("LONG_WITHER");
            STRONG_WITHER = Apoth.R.potion("STRONG_WITHER");
            VITALITY = Apoth.R.potion("VITALITY");
            LONG_VITALITY = Apoth.R.potion("LONG_VITALITY");
            STRONG_VITALITY = Apoth.R.potion("STRONG_VITALITY");
            GRIEVOUS = Apoth.R.potion("GRIEVOUS");
            LONG_GRIEVOUS = Apoth.R.potion("LONG_GRIEVOUS");
            STRONG_GRIEVOUS = Apoth.R.potion("STRONG_GRIEVOUS");
            LEVITATION = Apoth.R.potion("LEVITATION");
            FLYING = Apoth.R.potion("FLYING");
            LONG_FLYING = Apoth.R.potion("LONG_FLYING");
            EXTRA_LONG_FLYING = Apoth.R.potion("EXTRA_LONG_FLYING");
        }
    }
    
    public static final class Entities
    {
        public static final RegistryObject<EntityType<ObsidianArrowEntity>> OBSIDIAN_ARROW;
        public static final RegistryObject<EntityType<BroadheadArrowEntity>> BROADHEAD_ARROW;
        public static final RegistryObject<EntityType<ExplosiveArrowEntity>> EXPLOSIVE_ARROW;
        public static final RegistryObject<EntityType<MiningArrowEntity>> MINING_ARROW;
        
        static {
            OBSIDIAN_ARROW = Apoth.R.entity("OBSIDIAN_ARROW");
            BROADHEAD_ARROW = Apoth.R.entity("BROADHEAD_ARROW");
            EXPLOSIVE_ARROW = Apoth.R.entity("EXPLOSIVE_ARROW");
            MINING_ARROW = Apoth.R.entity("MINING_ARROW");
        }
    }
    
    public static final class Menus
    {
        public static final RegistryObject<MenuType<FletchingContainer>> FLETCHING;
        public static final RegistryObject<MenuType<EnchLibraryContainer>> LIBRARY;
        public static final RegistryObject<MenuType<ApothEnchantmentMenu>> ENCHANTING_TABLE;
        
        static {
            FLETCHING = Apoth.R.menu("fletching");
            LIBRARY = Apoth.R.menu("library");
            ENCHANTING_TABLE = Apoth.R.menu("enchanting_table");
        }
    }
    
    public static final class Tiles
    {
        public static final RegistryObject<BlockEntityType<EnchLibraryTile>> LIBRARY;
        public static final RegistryObject<BlockEntityType<AnvilTile>> ANVIL;
        public static final RegistryObject<BlockEntityType<EnchLibraryTile>> ENDER_LIBRARY;
        public static final RegistryObject<BlockEntityType<BossSpawnerBlock.BossSpawnerTile>> BOSS_SPAWNER;
        public static final RegistryObject<BlockEntityType<ReforgingTableTile>> REFORGING_TABLE;
        public static final RegistryObject<BlockEntityType<SalvagingTableTile>> SALVAGING_TABLE;
        public static final RegistryObject<BlockEntityType<AugmentingTableTile>> AUGMENTING_TABLE;
        
        static {
            LIBRARY = Apoth.R.blockEntity("LIBRARY");
            ANVIL = Apoth.R.blockEntity("ANVIL");
            ENDER_LIBRARY = Apoth.R.blockEntity("ENDER_LIBRARY");
            BOSS_SPAWNER = Apoth.R.blockEntity("BOSS_SPAWNER");
            REFORGING_TABLE = Apoth.R.blockEntity("REFORGING_TABLE");
            SALVAGING_TABLE = Apoth.R.blockEntity("SALVAGING_TABLE");
            AUGMENTING_TABLE = Apoth.R.blockEntity("augmenting_table");
        }
    }
    
    public static final class Affixes
    {
        public static final DynamicHolder<DurableAffix> DURABLE;
        public static final DynamicHolder<MagicalArrowAffix> MAGICAL;
        public static final DynamicHolder<FestiveAffix> FESTIVE;
        public static final DynamicHolder<TelepathicAffix> TELEPATHIC;
        public static final DynamicHolder<OmneticAffix> OMNETIC;
        public static final DynamicHolder<RadialAffix> RADIAL;
        
        static {
            DURABLE = AffixRegistry.INSTANCE.holder(Apotheosis.loc("durable"));
            MAGICAL = AffixRegistry.INSTANCE.holder(Apotheosis.loc("ranged/special/magical"));
            FESTIVE = AffixRegistry.INSTANCE.holder(Apotheosis.loc("sword/special/festive"));
            TELEPATHIC = AffixRegistry.INSTANCE.holder(Apotheosis.loc("telepathic"));
            OMNETIC = AffixRegistry.INSTANCE.holder(Apotheosis.loc("breaker/special/omnetic"));
            RADIAL = AffixRegistry.INSTANCE.holder(Apotheosis.loc("breaker/special/radial"));
        }
    }
    
    public static final class Tags
    {
        public static final TagKey<Item> BOON_DROPS;
        public static final TagKey<Item> SPEARFISHING_DROPS;
        public static final TagKey<Block> ROGUE_SPAWNER_COVERS;
        
        static {
            BOON_DROPS = ItemTags.create(new ResourceLocation("apotheosis", "boon_drops"));
            SPEARFISHING_DROPS = ItemTags.create(new ResourceLocation("apotheosis", "spearfishing_drops"));
            ROGUE_SPAWNER_COVERS = BlockTags.create(new ResourceLocation("apotheosis", "rogue_spawner_covers"));
        }
    }
    
    public static final class RecipeTypes
    {
        public static final RecipeType<FletchingRecipe> FLETCHING;
        public static final RecipeType<EnchantingRecipe> INFUSION;
        public static final RecipeType<SpawnerModifier> MODIFIER;
        public static final RecipeType<SalvagingRecipe> SALVAGING;
        public static final RecipeType<ReforgingRecipe> REFORGING;
        
        static {
            FLETCHING = PlaceboUtil.makeRecipeType("apotheosis:fletching");
            INFUSION = PlaceboUtil.makeRecipeType("apotheosis:enchanting");
            MODIFIER = PlaceboUtil.makeRecipeType("apotheosis:spawner_modifier");
            SALVAGING = PlaceboUtil.makeRecipeType("apotheosis:salvaging");
            REFORGING = PlaceboUtil.makeRecipeType("apotheosis:reforging");
        }
    }
    
    public static final class LootTables
    {
        public static final ResourceLocation CHEST_VALUABLE;
        public static final ResourceLocation SPAWNER_BRUTAL_ROTATE;
        public static final ResourceLocation SPAWNER_BRUTAL;
        public static final ResourceLocation SPAWNER_SWARM;
        public static final ResourceLocation TOME_TOWER;
        
        static {
            CHEST_VALUABLE = Apotheosis.loc("chests/chest_valuable");
            SPAWNER_BRUTAL_ROTATE = Apotheosis.loc("chests/spawner_brutal_rotate");
            SPAWNER_BRUTAL = Apotheosis.loc("chests/spawner_brutal");
            SPAWNER_SWARM = Apotheosis.loc("chests/spawner_swarm");
            TOME_TOWER = Apotheosis.loc("chests/tome_tower");
        }
    }
    
    public static final class Particles
    {
        public static final RegistryObject<SimpleParticleType> ENCHANT_FIRE;
        public static final RegistryObject<SimpleParticleType> ENCHANT_WATER;
        public static final RegistryObject<SimpleParticleType> ENCHANT_SCULK;
        public static final RegistryObject<SimpleParticleType> ENCHANT_END;
        
        static {
            ENCHANT_FIRE = Apoth.R.particle("enchant_fire");
            ENCHANT_WATER = Apoth.R.particle("enchant_water");
            ENCHANT_SCULK = Apoth.R.particle("enchant_sculk");
            ENCHANT_END = Apoth.R.particle("enchant_end");
        }
    }
    
    public static final class DamageTypes
    {
        public static final ResourceKey<DamageType> EXECUTE;
        public static final ResourceKey<DamageType> PSYCHIC;
        public static final ResourceKey<DamageType> CORRUPTED;
        
        static {
            EXECUTE = ResourceKey.m_135785_(Registries.f_268580_, Apotheosis.loc("execute"));
            PSYCHIC = ResourceKey.m_135785_(Registries.f_268580_, Apotheosis.loc("psychic"));
            CORRUPTED = ResourceKey.m_135785_(Registries.f_268580_, Apotheosis.loc("corrupted"));
        }
    }
}
